//
//  SAViewController.m
//  Test
//
//  Created by yusian on 15-4-4.
//  Copyright (c) 2015年 Sian. All rights reserved.
//

#import "SAViewController.h"
#import <AddressBook/AddressBook.h>

@interface SAViewController ()

@end

@implementation SAViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    ABAddressBookRef bookRef = ABAddressBookCreateWithOptions(nil, nil);
    
    //获取本地通讯录访问权限
    ABAddressBookRequestAccessWithCompletion(bookRef, ^(bool granted, CFErrorRef error){
        NSArray *array = [self getContacts:bookRef];
        NSLog(@"%@", array);
    });
}

- (NSArray *)getContacts:(ABAddressBookRef)adress

{
    // 1、获取通讯录
    CFArrayRef results = ABAddressBookCopyArrayOfAllPeople(adress);

    // 2、遍历通讯录
    NSMutableArray *array = [NSMutableArray array];
    
    for (int i = 0; i < CFArrayGetCount(results); i++){
        
        // 2.1、获取单条记录
        ABRecordRef person = CFArrayGetValueAtIndex(results, i);
        
        // 2.2、取记录中的名字
        NSString *firstName = (__bridge NSString*)ABRecordCopyValue(person, kABPersonFirstNameProperty);
        NSString *name = (__bridge NSString*)ABRecordCopyValue(person, kABPersonLastNameProperty);
        if (firstName) name = [name stringByAppendingString:firstName];                     // 名字拼接
   
        // 2.3、取记录中的号码（可能存在多个）
        ABMultiValueRef phones = ABRecordCopyValue(person, kABPersonPhoneProperty);         // 所有号码
        for (int k = 0; k < ABMultiValueGetCount(phones); k++){                             // 遍历取值
            NSString * phone = (__bridge NSString*)ABMultiValueCopyValueAtIndex(phones, k); // 取出号码
            // 拼接姓名号码，如：（张三：15555555555：18888888888）
            name = [name stringByAppendingFormat:@":%@", phone];
        }
        // 添加到数组，强烈建议在此创建一个通讯录的模型来接收数据，将数据保存到数组！
        if (name) [array addObject:name];
    }
    return array;
}

@end
